% (C) Mario Guimaraes 16 Dez 2001

function runtest(bIsSpatial_, nsubjects_, nsbjcategories_, maxsbj_power_, natoms_, maxatom_weigth_, ...
    atest, psubjects_, nminradius_, nmaxradius_, nminsubspercli_, nmaxsubspercli_, ...
    nMaxIteration_, npopsize_, ngroups_, useElitism_, pCrossover_, pMutation_, ...
    pSwitchCrossover_, pSwitchSelection_, pTournament_)

global root

nnotif = 1000;
atest = myunique(fix(atest));

testpath = strcat('_spc', num2str(bIsSpatial_), '_sbj', num2str(nsubjects_), '_cat',  num2str(nsbjcategories_), ...
    '_pow', num2str(maxsbj_power_), '_ato', num2str(natoms_), '_atow', num2str(maxatom_weigth_), ...
    '_psbj', num2str(psubjects_), '_minr', num2str(nminradius_), '_maxr', num2str(nmaxradius_), ...
    '_minsub', num2str(nminsubspercli_), '_maxsub', num2str(nmaxsubspercli_));
    
genpath = strcat('_pop', num2str(npopsize_), '_grp', num2str(ngroups_), '_maxiter', num2str(nMaxIteration_), ...
    '_elit', num2str(useElitism_), '_pc', num2str(pCrossover_), '_pm', num2str(pMutation_), ...
    '_psc', num2str(pSwitchCrossover_), '_pss', num2str(pSwitchSelection_), '_pt', num2str(pTournament_));

testname = strcat('test', testpath, genpath);

test_file = strcat(root, '\runs\', testname, '.mat');

try
    load(test_file, '-mat');
    anewtest = setdiff(atest, atdata(:,1)); % compute only new client cenaries
    idx = size(atdata, 1) + 1;
catch
    atdata = zeros(length(atest), 24);
    anewtest = atest;
    idx = 1;
end

if ~isempty(anewtest)
    for nclients_ = anewtest
        load(runcenary(bIsSpatial_, nsubjects_, nsbjcategories_, maxsbj_power_, natoms_, maxatom_weigth_, ...
            nclients_, psubjects_, nminradius_, nmaxradius_, nminsubspercli_, nmaxsubspercli_));

        load(rungenetic(cenname, nMaxIteration_, npopsize_, ngroups_, useElitism_, pCrossover_, pMutation_, ...
            pSwitchCrossover_, pSwitchSelection_, pTournament_, ...
            asubjects, achosensubs, aclientsubs, asubscriptions, aclients, aclient_bin_subs, aWeights, nSubsMulticast, nSubs));

        [nonlyunicast, nunicasts, nmulticasts, nmulticastsrep, nok, nokdup, nbad, nbaddup] = test(nnotif, indf, ...
            nSubsUnicast, nSubsMulticast, aWeightsCS, achosensubs, asubscriptions, aclients);

        atdata(idx,1) = nclients_;

        atdata(idx,2) = nonlyunicast;
        atdata(idx,3) = nunicasts;
        atdata(idx,4) = nmulticasts;
        atdata(idx,5) = nok;
        atdata(idx,6) = nbad;
        atdata(idx,7) = nok / (nok + nbad);

        [nonlyunicast, nunicasts, nmulticasts, nmulticastsrep, nok, nokdup, nbad, nbaddup] = test(nnotif, ind0, ...
            nSubsUnicast, nSubsMulticast, aWeightsCS, achosensubs, asubscriptions, aclients);

        atdata(idx,8) = nmulticasts;
        atdata(idx,9) = nmulticastsrep;
        atdata(idx,10) = nok;
        atdata(idx,11) = nokdup;
        atdata(idx,12) = nbad;
        atdata(idx,13) = nbaddup;
        atdata(idx,14) = nok / (nok + nokdup + nbad + nbaddup);

        [nonlyunicast, nunicasts, nmulticasts, nmulticastsrep, nok, nokdup, nbad, nbaddup] = test(nnotif, solution, ...
            nSubsUnicast, nSubsMulticast, aWeightsCS, achosensubs, asubscriptions, aclients);

        atdata(idx,15) = nmulticasts;
        atdata(idx,16) = nmulticastsrep;
        atdata(idx,17) = nok;
        atdata(idx,18) = nokdup;
        atdata(idx,19) = nbad;
        atdata(idx,20) = nbaddup;
        atdata(idx,21) = nok / (nok + nokdup + nbad + nbaddup);

        atdata(idx,22) = nSubs;
        atdata(idx,23) = nSubsUnicast;
        atdata(idx,24) = nSubsMulticast;

        idx = idx + 1;
    end
    
    save(test_file, 'atdata', '-mat');
end

%
% Log all genetic and test data in history file
% For each client number configuration, select results from test & genetic files.
%

atmp = atdata(:,1); % Get client configurations in test file
ndx = [];

for nelem = atest % Select wanted client configurations
    idx = find(nelem == atmp);
    ndx = [ndx idx];
end

logtests(testname, atdata(ndx,:)); % Log test results for each client configuration

for nelem = atest % Log genetic results for each client configuration
    cenpath = strcat('_spc', num2str(bIsSpatial_), '_sbj', num2str(nsubjects_), '_cat',  num2str(nsbjcategories_), ...
        '_pow', num2str(maxsbj_power_), '_ato', num2str(natoms_), '_atow', num2str(maxatom_weigth_), ...
        '_cli', num2str(nelem), '_psbj', num2str(psubjects_), '_minr', num2str(nminradius_), '_maxr', num2str(nmaxradius_), ...
        '_minsub', num2str(nminsubspercli_), '_maxsub', num2str(nmaxsubspercli_));

    genkey = strcat('cen', cenpath, '\genetic', genpath);
    genetic_file = strcat(root, '\runs\', genkey, '.mat');
    load(genetic_file, 'cost0', 'cost');
    loggen(genkey, cost0, cost);
end



function logtests(name, atdata)
global ahistory;

if isempty(ahistory.tkey)
    ahistory.tkey{1,1} = name;
    ahistory.tdata{1} = atdata;
else
    bfound = 0;
        
    for idx = 1:size(ahistory.tkey,1)
        if strcmp(name, ahistory.tkey{idx,1})
            ahistory.tdata{idx} = atdata;
            bfound = 1;
            break;
        end;
    end

    if ~bfound
        idx = idx + 1;
        ahistory.tkey{idx,1} = name;
        ahistory.tdata{idx} = atdata;
    end
end



function loggen(name, cost_ini, cost_final)
global ahistory;

if isempty(ahistory.genkey)
    ahistory.genkey{1,1} = name;
    ahistory.gencost(1,:) = [cost_ini cost_final];
else
    bfound = 0;
        
    for idx = 1:size(ahistory.genkey,1)
        if strcmp(name, ahistory.genkey{idx,1})
            ahistory.gencost(idx,:) = [cost_ini cost_final];
            bfound = 1;
            break;
        end
    end
        
    if ~bfound
        idx = idx + 1;
        ahistory.genkey{idx,1} = name;
        ahistory.gencost(idx,:) = [cost_ini cost_final];
    end
end