% (C) Mario Guimaraes 18 Nov 2001

function [nonlyunicast, nunicasts, nmulticasts, nmulticastsrep, nok, nokdup, nbad, nbaddup] = test(nnotif, ind, ...
    nSubsUnicast, nSubsMulticast, aWeightsCS, achosensubs, asubscriptions, aclients)

global nseed nclients nsubjects natoms

rand('state', nseed);

[agroup_clients, aunicast, amulticast] = prepare_test(ind, nSubsUnicast, nSubsMulticast, ...
    achosensubs, asubscriptions, aclients);

nonlyunicast = 0;
nunicasts = 0;
nmulticasts = 0;
nmulticastsrep = 0;

%anotifications = zeros(nclients, 4); % Para cada cliente conta mensagens ok, dup_ok, bad, dup_bad
nok = 0;
nokdup = 0;
nbad = 0;
nbaddup = 0;

for i = 1:nnotif
    % Escolhe atomo da notificacao
    atom = notif_atom(aWeightsCS);

    % Multicast ?
    aidx = find(amulticast(2,:) <= atom & amulticast(3,:) >= atom);
    
    if ~isempty(aidx)
        agroups = double(myunique(amulticast(4,aidx)));
        nmulticasts = nmulticasts + 1;
        nmulticastsrep = nmulticastsrep + length(agroups) - 1;

        % Conta notificacoes recebidas pelos clientes
        anotif = zeros(nclients, 1);
        for g = agroups
            arcv = double(agroup_clients{g});
            anotif(arcv) = anotif(arcv) + 1;
        end
        arcv = myunique([agroup_clients{agroups}]);

        % Conta notificacoes ok e dup_ok
        aclis = double(myunique([aclients{double(amulticast(1,aidx))}]));
        
%        anotifications(aclis,1) = anotifications(aclis,1) + 1;
%        anotifications(aclis,2) = anotifications(aclis,2) + anotif(aclis) - 1;
%        nonlyunicast = nonlyunicast + length(aclis);
        
        nlen = length(aclis);
        nok = nok + nlen;
        nokdup = nokdup + sum(anotif(aclis)) - nlen;
        nonlyunicast = nonlyunicast + nlen;
        
        % Conta notificacoes bad e dup_bad
        aclis = mysetdiff(arcv, aclis);
        
        if ~isempty(aclis)
%            anotifications(aclis,3) = anotifications(aclis,3) + 1;
%            anotifications(aclis,4) = anotifications(aclis,4) + anotif(aclis) - 1;
            
            nlen = length(aclis);
            nbad = nbad + nlen;
            nbaddup = nbaddup + sum(anotif(aclis)) - nlen;
        end
    end
    
    % Unicast ?
    if size(aunicast,2) > 0
        aidx = find(aunicast(2,:) <= atom & aunicast(3,:) >= atom);
    
        if ~isempty(aidx)
            aclis = [aclients{double(aunicast(1,aidx))}];
            nlen = length(aclis);
            nunicasts = nunicasts + nlen;
            nonlyunicast = nonlyunicast + nlen;
        end
    end
end