#include <math.h>
#include "mex.h"
#include "union_bs_f.h"

#define I_ASUBS prhs[0]
#define I_NATOMS prhs[1]
#define O_BDATA plhs[0]

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    int dims[2], nAtoms;

    /* Check for proper arguments */
	if (nrhs != 2)
		mexErrMsgTxt("Two input arguments are required.");
    else if (nlhs > 1)
		mexErrMsgTxt("Too many output arguments.");

	if (!mxIsUint16(I_ASUBS) || mxGetM(I_ASUBS) != 2)
		mexErrMsgTxt("First input argument must be an 2-by-N array of UINT16.");

    /* Create a vector of 32bit integers */
    dims[0] = 1;
    dims[1] = ((UINT)mxGetScalar(I_NATOMS)) / ULONG_BITS;
    O_BDATA = mxCreateNumericArray(2,dims,mxUINT32_CLASS,mxREAL);
   
    /* Do the actual computations in a subroutine */
	union_bs_f(mxGetPr(I_ASUBS), mxGetN(I_ASUBS), mxGetPr(O_BDATA));
    return;
}
